gi-gtk-3.0.43: Gtk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.Scale

Contents

- Exported types
- Methods
  - addMark
  - clearMarks
  - getDigits
  - getDrawValue
  - getHasOrigin
  - getLayout
  - getLayoutOffsets
  - getValuePos
  - new
  - newWithRange
  - setDigits
  - setDrawValue
  - setHasOrigin
  - setValuePos
- Properties
  - digits
  - drawValue
  - hasOrigin
  - valuePos
- Signals
  - formatValue

Description

A GtkScale is a slider control used to select a numeric value. To use it, you’ll probably want to investigate the methods on its base class, `Range`, in addition to the methods for GtkScale itself. To set the value of a scale, you would normally use `rangeSetValue`. To detect changes to the value, you would normally use the Range::valueChanged signal.

Note that using the same upper and lower bounds for the `Scale` (through the `Range` methods) will hide the slider itself. This is useful for applications that want to show an undeterminate value on the scale, without changing the layout of the application (such as movie or music players).

# GtkScale as GtkBuildable

GtkScale supports a custom `<marks>` element, which can contain multiple `<mark>` elements. The “value” and “position” attributes have the same meaning as `scaleAddMark` parameters of the same name. If the element is not empty, its content is taken as the markup to show at the mark. It can be translated with the usual ”translatable” and “context” attributes.

# CSS nodes

### plain code

    scale[.fine-tune][.marks-before][.marks-after]
    ├── marks.top
    │   ├── mark
    │   ┊    ├── [label]
    │   ┊    ╰── indicator
    ┊   ┊
    │   ╰── mark
    ├── [value]
    ├── contents
    │   ╰── trough
    │       ├── slider
    │       ├── [highlight]
    │       ╰── [fill]
    ╰── marks.bottom
        ├── mark
        ┊    ├── indicator
        ┊    ╰── [label]
        ╰── mark

GtkScale has a main CSS node with name scale and a subnode for its contents, with subnodes named trough and slider.

The main node gets the style class .fine-tune added when the scale is in 'fine-tuning' mode.

If the scale has an origin (see `scaleSetHasOrigin`), there is a subnode with name highlight below the trough node that is used for rendering the highlighted part of the trough.

If the scale is showing a fill level (see `rangeSetShowFillLevel`), there is a subnode with name fill below the trough node that is used for rendering the filled in part of the trough.

If marks are present, there is a marks subnode before or after the contents node, below which each mark gets a node with name mark. The marks nodes get either the .top or .bottom style class.

The mark node has a subnode named indicator. If the mark has text, it also has a subnode named label. When the mark is either above or left of the scale, the label subnode is the first when present. Otherwise, the indicator subnode is the first.

The main CSS node gets the 'marks-before' and/or 'marks-after' style classes added depending on what marks are present.

If the scale is displaying the value (see Scale:drawValue), there is subnode with name value.

Synopsis

- newtype Scale = Scale (ManagedPtr Scale)
- class (GObject o, IsDescendantOf Scale o) => IsScale o
- toScale :: (MonadIO m, IsScale o) => o -> m Scale
- scaleAddMark :: (HasCallStack, MonadIO m, IsScale a) => a -> Double -> PositionType -> Maybe Text -> m ()
- scaleClearMarks :: (HasCallStack, MonadIO m, IsScale a) => a -> m ()
- scaleGetDigits :: (HasCallStack, MonadIO m, IsScale a) => a -> m Int32
- scaleGetDrawValue :: (HasCallStack, MonadIO m, IsScale a) => a -> m Bool
- scaleGetHasOrigin :: (HasCallStack, MonadIO m, IsScale a) => a -> m Bool
- scaleGetLayout :: (HasCallStack, MonadIO m, IsScale a) => a -> m (Maybe Layout)
- scaleGetLayoutOffsets :: (HasCallStack, MonadIO m, IsScale a) => a -> m (Int32, Int32)
- scaleGetValuePos :: (HasCallStack, MonadIO m, IsScale a) => a -> m PositionType
- scaleNew :: (HasCallStack, MonadIO m, IsAdjustment a) => Orientation -> Maybe a -> m Scale
- scaleNewWithRange :: (HasCallStack, MonadIO m) => Orientation -> Double -> Double -> Double -> m Scale
- scaleSetDigits :: (HasCallStack, MonadIO m, IsScale a) => a -> Int32 -> m ()
- scaleSetDrawValue :: (HasCallStack, MonadIO m, IsScale a) => a -> Bool -> m ()
- scaleSetHasOrigin :: (HasCallStack, MonadIO m, IsScale a) => a -> Bool -> m ()
- scaleSetValuePos :: (HasCallStack, MonadIO m, IsScale a) => a -> PositionType -> m ()
- constructScaleDigits :: (IsScale o, MonadIO m) => Int32 -> m (GValueConstruct o)
- getScaleDigits :: (MonadIO m, IsScale o) => o -> m Int32
- setScaleDigits :: (MonadIO m, IsScale o) => o -> Int32 -> m ()
- constructScaleDrawValue :: (IsScale o, MonadIO m) => Bool -> m (GValueConstruct o)
- getScaleDrawValue :: (MonadIO m, IsScale o) => o -> m Bool
- setScaleDrawValue :: (MonadIO m, IsScale o) => o -> Bool -> m ()
- constructScaleHasOrigin :: (IsScale o, MonadIO m) => Bool -> m (GValueConstruct o)
- getScaleHasOrigin :: (MonadIO m, IsScale o) => o -> m Bool
- setScaleHasOrigin :: (MonadIO m, IsScale o) => o -> Bool -> m ()
- constructScaleValuePos :: (IsScale o, MonadIO m) => PositionType -> m (GValueConstruct o)
- getScaleValuePos :: (MonadIO m, IsScale o) => o -> m PositionType
- setScaleValuePos :: (MonadIO m, IsScale o) => o -> PositionType -> m ()
- type ScaleFormatValueCallback = Double -> IO Text
- afterScaleFormatValue :: (IsScale a, MonadIO m) => a -> ((?self :: a) => ScaleFormatValueCallback) -> m SignalHandlerId
- onScaleFormatValue :: (IsScale a, MonadIO m) => a -> ((?self :: a) => ScaleFormatValueCallback) -> m SignalHandlerId

# Exported types

newtype Scale Source #

Memory-managed wrapper type.

Constructors

Scale (ManagedPtr Scale) |

#### Instances

Instances details

Eq Scale Source # |
Instance details Defined in GI.Gtk.Objects.Scale Methods (==) :: Scale -> Scale -> Bool Source # (/=) :: Scale -> Scale -> Bool Source #
GObject Scale Source # |
Instance details Defined in GI.Gtk.Objects.Scale
ManagedPtrNewtype Scale Source # |
Instance details Defined in GI.Gtk.Objects.Scale Methods toManagedPtr :: Scale -> ManagedPtr Scale Source #
TypedObject Scale Source # |
Instance details Defined in GI.Gtk.Objects.Scale Methods glibType :: IO GType Source #
HasParentTypes Scale Source # |
Instance details Defined in GI.Gtk.Objects.Scale
IsGValue (Maybe Scale) Source # | Convert `Scale` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.Scale Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Scale -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Scale) Source #
type ParentTypes Scale Source # |
Instance details Defined in GI.Gtk.Objects.Scale type ParentTypes Scale = '[Range, Widget, Object, ImplementorIface, Buildable, Orientable]

class (GObject o, IsDescendantOf Scale o) => IsScale o Source #

Type class for types which can be safely cast to `Scale`, for instance with `toScale`.

#### Instances

Instances details

(GObject o, IsDescendantOf Scale o) => IsScale o Source # |
Instance details Defined in GI.Gtk.Objects.Scale

toScale :: (MonadIO m, IsScale o) => o -> m Scale Source #

Cast to `Scale`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

activate, addAccelerator, addChild, addDeviceEvents, addEvents, addMark, addMnemonicLabel, addTickCallback, bindProperty, bindPropertyFull, canActivateAccel, childFocus, childNotify, classPath, clearMarks, computeExpand, constructChild, createPangoContext, createPangoLayout, customFinished, customTagEnd, customTagStart, destroy, destroyed, deviceIsShadowed, dragBegin, dragBeginWithCoordinates, dragCheckThreshold, dragDestAddImageTargets, dragDestAddTextTargets, dragDestAddUriTargets, dragDestFindTarget, dragDestGetTargetList, dragDestGetTrackMotion, dragDestSet, dragDestSetProxy, dragDestSetTargetList, dragDestSetTrackMotion, dragDestUnset, dragGetData, dragHighlight, dragSourceAddImageTargets, dragSourceAddTextTargets, dragSourceAddUriTargets, dragSourceGetTargetList, dragSourceSet, dragSourceSetIconGicon, dragSourceSetIconName, dragSourceSetIconPixbuf, dragSourceSetIconStock, dragSourceSetTargetList, dragSourceUnset, dragUnhighlight, draw, ensureStyle, errorBell, event, forceFloating, freezeChildNotify, freezeNotify, getv, grabAdd, grabDefault, grabFocus, grabRemove, hasDefault, hasFocus, hasGrab, hasRcStyle, hasScreen, hasVisibleFocus, hide, hideOnDelete, inDestruction, initTemplate, inputShapeCombineRegion, insertActionGroup, intersect, isAncestor, isComposited, isDrawable, isFloating, isFocus, isSensitive, isToplevel, isVisible, keynavFailed, listAccelClosures, listActionPrefixes, listMnemonicLabels, map, mnemonicActivate, modifyBase, modifyBg, modifyCursor, modifyFg, modifyFont, modifyStyle, modifyText, notify, notifyByPspec, overrideBackgroundColor, overrideColor, overrideCursor, overrideFont, overrideSymbolicColor, parserFinished, path, queueAllocate, queueComputeExpand, queueDraw, queueDrawArea, queueDrawRegion, queueResize, queueResizeNoRedraw, realize, ref, refSink, regionIntersect, registerWindow, removeAccelerator, removeMnemonicLabel, removeTickCallback, renderIcon, renderIconPixbuf, reparent, resetRcStyles, resetStyle, runDispose, sendExpose, sendFocusChange, shapeCombineRegion, show, showAll, showNow, sizeAllocate, sizeAllocateWithBaseline, sizeRequest, stealData, stealQdata, styleAttach, styleGetProperty, thawChildNotify, thawNotify, translateCoordinates, triggerTooltipQuery, unmap, unparent, unrealize, unref, unregisterWindow, unsetStateFlags, watchClosure.

#### Getters

getAccessible, getActionGroup, getAdjustment, getAllocatedBaseline, getAllocatedHeight, getAllocatedSize, getAllocatedWidth, getAllocation, getAncestor, getAppPaintable, getCanDefault, getCanFocus, getChildRequisition, getChildVisible, getClip, getClipboard, getCompositeName, getData, getDeviceEnabled, getDeviceEvents, getDigits, getDirection, getDisplay, getDoubleBuffered, getDrawValue, getEvents, getFillLevel, getFlippable, getFocusOnClick, getFontMap, getFontOptions, getFrameClock, getHalign, getHasOrigin, getHasTooltip, getHasWindow, getHexpand, getHexpandSet, getInternalChild, getInverted, getLayout, getLayoutOffsets, getLowerStepperSensitivity, getMapped, getMarginBottom, getMarginEnd, getMarginLeft, getMarginRight, getMarginStart, getMarginTop, getMinSliderSize, getModifierMask, getModifierStyle, getName, getNoShowAll, getOpacity, getOrientation, getPangoContext, getParent, getParentWindow, getPath, getPointer, getPreferredHeight, getPreferredHeightAndBaselineForWidth, getPreferredHeightForWidth, getPreferredSize, getPreferredWidth, getPreferredWidthForHeight, getProperty, getQdata, getRangeRect, getRealized, getReceivesDefault, getRequestMode, getRequisition, getRestrictToFillLevel, getRootWindow, getRoundDigits, getScaleFactor, getScreen, getSensitive, getSettings, getShowFillLevel, getSizeRequest, getSliderRange, getSliderSizeFixed, getState, getStateFlags, getStyle, getStyleContext, getSupportMultidevice, getTemplateChild, getTooltipMarkup, getTooltipText, getTooltipWindow, getToplevel, getUpperStepperSensitivity, getValign, getValignWithBaseline, getValue, getValuePos, getVexpand, getVexpandSet, getVisible, getVisual, getWindow.

#### Setters

setAccelPath, setAdjustment, setAllocation, setAppPaintable, setBuildableProperty, setCanDefault, setCanFocus, setChildVisible, setClip, setCompositeName, setData, setDataFull, setDeviceEnabled, setDeviceEvents, setDigits, setDirection, setDoubleBuffered, setDrawValue, setEvents, setFillLevel, setFlippable, setFocusOnClick, setFontMap, setFontOptions, setHalign, setHasOrigin, setHasTooltip, setHasWindow, setHexpand, setHexpandSet, setIncrements, setInverted, setLowerStepperSensitivity, setMapped, setMarginBottom, setMarginEnd, setMarginLeft, setMarginRight, setMarginStart, setMarginTop, setMinSliderSize, setName, setNoShowAll, setOpacity, setOrientation, setParent, setParentWindow, setProperty, setRange, setRealized, setReceivesDefault, setRedrawOnAllocate, setRestrictToFillLevel, setRoundDigits, setSensitive, setShowFillLevel, setSizeRequest, setSliderSizeFixed, setState, setStateFlags, setStyle, setSupportMultidevice, setTooltipMarkup, setTooltipText, setTooltipWindow, setUpperStepperSensitivity, setValign, setValue, setValuePos, setVexpand, setVexpandSet, setVisible, setVisual, setWindow.

## addMark

scaleAddMark Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> Double | `value`: the value at which the mark is placed, must be between the lower and upper limits of the scales’ adjustment
-> PositionType | `position`: where to draw the mark. For a horizontal scale, `GTK_POS_TOP` and `PositionTypeLeft` are drawn above the scale, anything else below. For a vertical scale, `GTK_POS_LEFT` and `PositionTypeTop` are drawn to the left of the scale, anything else to the right.
-> Maybe Text | `markup`: Text to be shown at the mark, using [Pango markup][PangoMarkupFormat], or `Nothing`
-> m () |

Adds a mark at `value`.

A mark is indicated visually by drawing a tick mark next to the scale, and GTK+ makes it easy for the user to position the scale exactly at the marks value.

If `markup` is not `Nothing`, text is shown next to the tick mark.

To remove marks from a scale, use `scaleClearMarks`.

Since: 2.16

## clearMarks

scaleClearMarks Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> m () |

Removes any marks that have been added with `scaleAddMark`.

Since: 2.16

## getDigits

scaleGetDigits Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> m Int32 | Returns: the number of decimal places that are displayed

Gets the number of decimal places that are displayed in the value.

## getDrawValue

scaleGetDrawValue Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> m Bool | Returns: whether the current value is displayed as a string

Returns whether the current value is displayed as a string next to the slider.

## getHasOrigin

scaleGetHasOrigin Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> m Bool | Returns: `True` if the scale has an origin.

Returns whether the scale has an origin.

Since: 3.4

## getLayout

scaleGetLayout Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: A `Scale`
-> m (Maybe Layout) | Returns: the `Layout` for this scale, or `Nothing` if the Scale:drawValue property is `False`.

Gets the `Layout` used to display the scale. The returned object is owned by the scale so does not need to be freed by the caller.

Since: 2.4

## getLayoutOffsets

scaleGetLayoutOffsets Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> m (Int32, Int32) |

Obtains the coordinates where the scale will draw the `Layout` representing the text in the scale. Remember when using the `Layout` function you need to convert to and from pixels using `PANGO_PIXELS()` or `SCALE`.

If the Scale:drawValue property is `False`, the return values are undefined.

Since: 2.4

## getValuePos

scaleGetValuePos Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> m PositionType | Returns: the position in which the current value is displayed

Gets the position in which the current value is displayed.

## new

scaleNew Source #

Arguments

:: (HasCallStack, MonadIO m, IsAdjustment a) |
=> Orientation | `orientation`: the scale’s orientation.
-> Maybe a | `adjustment`: the `Adjustment` which sets the range of the scale, or `Nothing` to create a new adjustment.
-> m Scale | Returns: a new `Scale`

Creates a new `Scale`.

Since: 3.0

## newWithRange

scaleNewWithRange Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Orientation | `orientation`: the scale’s orientation.
-> Double | `min`: minimum value
-> Double | `max`: maximum value
-> Double | `step`: step increment (tick size) used with keyboard shortcuts
-> m Scale | Returns: a new `Scale`

Creates a new scale widget with the given orientation that lets the user input a number between `min` and `max` (including `min` and `max`) with the increment `step`. `step` must be nonzero; it’s the distance the slider moves when using the arrow keys to adjust the scale value.

Note that the way in which the precision is derived works best if `step` is a power of ten. If the resulting precision is not suitable for your needs, use `scaleSetDigits` to correct it.

Since: 3.0

## setDigits

scaleSetDigits Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> Int32 | `digits`: the number of decimal places to display, e.g. use 1 to display 1.0, 2 to display 1.00, etc
-> m () |

Sets the number of decimal places that are displayed in the value. Also causes the value of the adjustment to be rounded to this number of digits, so the retrieved value matches the displayed one, if Scale:drawValue is `True` when the value changes. If you want to enforce rounding the value when Scale:drawValue is `False`, you can set Range:roundDigits instead.

Note that rounding to a small number of digits can interfere with the smooth autoscrolling that is built into `Scale`. As an alternative, you can use the Scale::formatValue signal to format the displayed value yourself.

## setDrawValue

scaleSetDrawValue Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> Bool | `drawValue`: `True` to draw the value
-> m () |

Specifies whether the current value is displayed as a string next to the slider.

## setHasOrigin

scaleSetHasOrigin Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> Bool | `hasOrigin`: `True` if the scale has an origin
-> m () |

If Scale:hasOrigin is set to `True` (the default), the scale will highlight the part of the trough between the origin (bottom or left side) and the current value.

Since: 3.4

## setValuePos

scaleSetValuePos Source #

Arguments

:: (HasCallStack, MonadIO m, IsScale a) |
=> a | `scale`: a `Scale`
-> PositionType | `pos`: the position in which the current value is displayed
-> m () |

Sets the position in which the current value is displayed.

# Properties

## digits

No description available in the introspection data.

constructScaleDigits :: (IsScale o, MonadIO m) => Int32 -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`digits`” property. This is rarely needed directly, but it is used by `new`.

getScaleDigits :: (MonadIO m, IsScale o) => o -> m Int32 Source #

Get the value of the “`digits`” property. When overloading is enabled, this is equivalent to

    get scale #digits

setScaleDigits :: (MonadIO m, IsScale o) => o -> Int32 -> m () Source #

Set the value of the “`digits`” property. When overloading is enabled, this is equivalent to

    set scale [ #digits := value ]

## drawValue

No description available in the introspection data.

constructScaleDrawValue :: (IsScale o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`draw-value`” property. This is rarely needed directly, but it is used by `new`.

getScaleDrawValue :: (MonadIO m, IsScale o) => o -> m Bool Source #

Get the value of the “`draw-value`” property. When overloading is enabled, this is equivalent to

    get scale #drawValue

setScaleDrawValue :: (MonadIO m, IsScale o) => o -> Bool -> m () Source #

Set the value of the “`draw-value`” property. When overloading is enabled, this is equivalent to

    set scale [ #drawValue := value ]

## hasOrigin

No description available in the introspection data.

constructScaleHasOrigin :: (IsScale o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`has-origin`” property. This is rarely needed directly, but it is used by `new`.

getScaleHasOrigin :: (MonadIO m, IsScale o) => o -> m Bool Source #

Get the value of the “`has-origin`” property. When overloading is enabled, this is equivalent to

    get scale #hasOrigin

setScaleHasOrigin :: (MonadIO m, IsScale o) => o -> Bool -> m () Source #

Set the value of the “`has-origin`” property. When overloading is enabled, this is equivalent to

    set scale [ #hasOrigin := value ]

## valuePos

No description available in the introspection data.

constructScaleValuePos :: (IsScale o, MonadIO m) => PositionType -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`value-pos`” property. This is rarely needed directly, but it is used by `new`.

getScaleValuePos :: (MonadIO m, IsScale o) => o -> m PositionType Source #

Get the value of the “`value-pos`” property. When overloading is enabled, this is equivalent to

    get scale #valuePos

setScaleValuePos :: (MonadIO m, IsScale o) => o -> PositionType -> m () Source #

Set the value of the “`value-pos`” property. When overloading is enabled, this is equivalent to

    set scale [ #valuePos := value ]

# Signals

## formatValue

type ScaleFormatValueCallback Source #

Arguments

= Double | `value`: the value to format
-> IO Text | Returns: allocated string representing `value`

Signal which allows you to change how the scale value is displayed. Connect a signal handler which returns an allocated string representing `value`. That string will then be used to display the scale's value.

If no user-provided handlers are installed, the value will be displayed on its own, rounded according to the value of the Scale:digits property.

Here's an example signal handler which displays a value 1.0 as with "-->1.0<--".

### C code

    static gchar*
    format_value_callback (GtkScale *scale,
                           gdouble   value)
    {
      return g_strdup_printf ("-->\%0.*g<--",
                              gtk_scale_get_digits (scale), value);
     }

afterScaleFormatValue :: (IsScale a, MonadIO m) => a -> ((?self :: a) => ScaleFormatValueCallback) -> m SignalHandlerId Source #

Connect a signal handler for the formatValue signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after scale #formatValue callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onScaleFormatValue :: (IsScale a, MonadIO m) => a -> ((?self :: a) => ScaleFormatValueCallback) -> m SignalHandlerId Source #

Connect a signal handler for the formatValue signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on scale #formatValue callback